<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\IntegracaoSMService;
use FM\Traits\TResponse;

class IntegracaoSMController extends FMCrud{

    use TResponse;
    
    protected $dataSourceName = 'fcm_checklistagend';
    protected $integracaoSMService;

    public function __construct($crudService, $environment, IntegracaoSMService $integracaoSMService) {
        parent::__construct($crudService, $environment);
        $this->IntegracaoSMService = $integracaoSMService;
        $this->Environment = $environment;
    }

    public function cadastrarLocais(Request $request, Response $response){
        try {

            $retorno = $this->IntegracaoSMService->cadastrarLocais($request->getDataSet()->getRows()[0]);
            $this->sendResponse(["dataset" => $retorno], 200);

          } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
         }
    }

    public function getDadosMedicao(Request $request, Response $response){
        try {

            $retorno = $this->IntegracaoSMService->getDadosMedicao($request->getDataSet()->getRows()[0]);
            $this->sendResponse(["dataset" => $retorno], 200);

          } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
         }
    }
}
?>