/*
-- ========================================================================== --
-- SISTEMA         : CONTAS A PAGAR                                           --
-- DATA DA CRIAO : 06/03/2002                                               --
-- PROGRAMADOR     : ANDR RODRIGO                                            --
-- OBJETIVOS       : ALTERA O TIPO DE RECEBIMENTO DO BOLETO                   --
-- @C:\WIN_PRJ\SQL\ORACLE\1005_RECSTP_ATUALIZA_TPRECBOLETO.SQL                --
-- ========================================================================== --
*/
CREATE OR REPLACE PROCEDURE ATUALIZA_TPRECBOLETO
  (P_CDFILIBAIREC IN BAIXARECEBIDA.CDFILIAL%TYPE,
   P_NRBAIXAREC   IN BAIXARECEBIDA.NRBAIXAREC%TYPE,
   P_VRBAIXAREC   IN BAIXARECEBIDA.VRBAIXAREC%TYPE) IS

   V_VRTPRECBOLR TPRECBOLETO.VRTPRECBOLR%TYPE;
BEGIN
   FOR C_BOLET IN
      (SELECT
          CDFILIAL, NRLANBOLREC, VRFINALBREC
       FROM BOLETRECEBER
       WHERE
         (CDFILIBAIREC = P_CDFILIBAIREC)   AND
         (NRBAIXAREC   = P_NRBAIXAREC)) LOOP

      DELETE FROM TPRECBOLETO
      WHERE
        (CDFILIAL     = C_BOLET.CDFILIAL)    AND
        (NRLANBOLREC  = C_BOLET.NRLANBOLREC);

      FOR C_BAIXA IN
         (SELECT
            CDFILIAL,     NRBAIXAREC,   CDTIPORECE,   NRSEQTPRECBA,
            CDCARTAO,     CDBANCBAIREC, VRTPRECBAIXA, CDAGENBAIREC,
            CDCONTBAIREC, NRCHEQBAIREC, NRCARCREBREC, DTCHEQBAIREC,DSCHEQBAIREC
          FROM TPRECBAIXA
          WHERE
            (CDFILIAL   = P_CDFILIBAIREC) AND
            (NRBAIXAREC = P_NRBAIXAREC)) LOOP

         V_VRTPRECBOLR := (C_BAIXA.VRTPRECBAIXA * C_BOLET.VRFINALBREC)/P_VRBAIXAREC;

         INSERT INTO TPRECBOLETO
            (CDFILIAL,     NRLANBOLREC,  CDTIPORECE,   NRSEQTPRECBO,
             VRTPRECBOLR,  NRCHEQBOLREC, DTCHEQBOLREC, CDBANCBOLREC,
             CDAGENBOLREC, CDCONTBOLREC, CDCARTAO,     NRCARCREBOLR,DSCHEQBOLREC)
         VALUES
            (C_BOLET.CDFILIAL, C_BOLET.NRLANBOLREC, C_BAIXA.CDTIPORECE, C_BAIXA.NRSEQTPRECBA,
             V_VRTPRECBOLR, C_BAIXA.NRCHEQBAIREC, C_BAIXA.DTCHEQBAIREC, C_BAIXA.CDBANCBAIREC,
             C_BAIXA.CDAGENBAIREC, C_BAIXA.CDCONTBAIREC, C_BAIXA.CDCARTAO, C_BAIXA.NRCARCREBREC,
             C_BAIXA.DSCHEQBAIREC);
      END LOOP;
   END LOOP;
END;
/

