/* eslint-disable */
import { Http, IDictionary, Metadata } from '@zeedhi/core';
import { Form, LoadingService, Modal, ModalService, Select, Textarea, TextInput } from '@zeedhi/common';
import { TekGrid } from '@zeedhi/teknisa-components-common';
import { Utilities } from '@/util/Utilities';

export class Fm00002TipoLocalController {
    private modalNovoTipoLocal!: Modal;

    private modalEditarTipoLocal!: Modal;

    private currentRow: any;

    public async abrirModal() {
        this.modalNovoTipoLocal = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00002_000_gerenciar_locais/modal/FM_00002_002_modal_novo_tipo_local' });
        await this.modalNovoTipoLocal.show();
    }

    public fecharModal() {
        this.modalNovoTipoLocal.hide();
        this.modalNovoTipoLocal?.destroy();
    }
    
    public async abrirModalEdicao({ row }: any) {
        this.modalEditarTipoLocal = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00002_000_gerenciar_locais/modal/FM_00002_002_modal_editar_tipo_local' });
        this.currentRow = row;
        await this.modalEditarTipoLocal.show();
    }

    public fecharModalEdicao() {
        this.modalEditarTipoLocal.hide();
        this.modalEditarTipoLocal?.destroy();
    }

    public montarInformacoesEdicao() {
        Metadata.getInstance<TextInput>('NRTIPOLOCALCLI-edicao').value = this.currentRow.NRTIPOLOCALCLI;
        Metadata.getInstance<TextInput>('NMTIPOLOCALCLI-edicao').value = this.currentRow.NMTIPOLOCALCLI;
        Metadata.getInstance<Select>('IDTIPOLOCALCLI-edicao').setValue(this.currentRow.IDTIPOLOCALCLI);
        Metadata.getInstance<Textarea>('DSTIPOLOCALCLI-edicao').value = this.currentRow.DSTIPOLOCALCLI;
    }

    public atualizarTipoLocal() {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-tipo-local');
        const form = Metadata.getInstance<Form>('form-edicao-tipo-local').validate();

        if (form) {
            LoadingService.show();
            Http.post('/atualizarTipoLocal', {
                NRTIPOLOCALCLI: Metadata.getInstance<TextInput>('NRTIPOLOCALCLI-edicao').value,
                NMTIPOLOCALCLI: Metadata.getInstance<TextInput>('NMTIPOLOCALCLI-edicao').value,
                IDTIPOLOCALCLI: Metadata.getInstance<Select>('IDTIPOLOCALCLI-edicao').value,
                DSTIPOLOCALCLI: Metadata.getInstance<Textarea>('DSTIPOLOCALCLI-edicao').value,
            }).then((response: IDictionary) => {
                Utilities.showSuccessMessage();
                grid.datasource.get();
                this.fecharModalEdicao();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
        } else {
            Utilities.alertMessage('Preencha todos os campos obrigatórios(*)!', 'error');
        }
    }

    public inserirTipoLocal() {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-tipo-local');
        const form = Metadata.getInstance<Form>('form-novo-tipo-local').validate();

        if (form) {
            LoadingService.show();
            Http.post('/inserirTipoLocal', {
                NMTIPOLOCALCLI: Metadata.getInstance<TextInput>('NMTIPOLOCALCLI-novo-tipo-de-local').value,
                IDTIPOLOCALCLI: Metadata.getInstance<Select>('IDTIPOLOCALCLI-novo-tipo-de-local').value,
                DSTIPOLOCALCLI: Metadata.getInstance<Textarea>('DSTIPOLOCALCLI-novo-tipo-de-local').value,
            }).then((response: IDictionary) => {
                Utilities.showSuccessMessage();
                grid.datasource.get();
                this.fecharModal();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
        } else {
            Utilities.alertMessage('Preencha todos os campos obrigatórios(*)!', 'error');
        }
    }
}
