/* eslint-disable */
import {
    Metadata, Http,
} from '@zeedhi/core';
import {
    AlertService, Button, DialogService, Modal, ModalService, Form, Select, TextInput, LoadingService,
} from '@zeedhi/common';
import { Utilities } from '@/util/Utilities';
import { ZdSelect } from '@zeedhi/vuetify';

export class ControllerParametrizacaoGeral {
    private mnemonicosModal!: Modal;

    public modificarUtilizacaoMascara({ component }: any) {
        const utilizarMascara = (component.value === "N");
        const mascara = Metadata.getInstance<TextInput>('InputMascara');
        mascara.disabled = utilizarMascara;
        Metadata.getInstance<Button>('BtnMnemonicos').disabled = utilizarMascara;
        Metadata.getInstance<Select>('SelectPermissao').disabled = utilizarMascara;
        if (utilizarMascara) {
            mascara.removeValidation('required');
        } else {
            mascara.addValidation('required');
        }
    }

    public cancelarMascara({ component }: any) {
        console.log('Cancelado');
    }

    public salvarMascara({ component }: any) {
        const form = Metadata.getInstance<Form>('formParametrizacao_dropBoxTarefas');
        //window.localStorage.removeItem('padraoMascara');

        // if (form.validate()) {
        //   const mnemonicos: any = ['SEQ', 'SETOR', 'NMABLOC', 'NMABLOCS', 'NMABLOCSALL'];
        //   const valuesOK: boolean = [
        //     ...new Set(
        //       (form.value.InputMascara.split(']').filter((elemento: any) => elemento.includes('[')))
        //         .map((elemento: any) => elemento.slice(elemento.indexOf('[') + 1))
        //         .map((elemento: any) => elemento.replace(elemento.substring(elemento.indexOf('{'), elemento.indexOf('}') + 1), ''))
        //         .map((elemento: any) => mnemonicos.includes(elemento.toLocaleUpperCase()))
        //     )
        //   ].includes(false);
        //   if (valuesOK) {
        //     this.dialogMessage('Mnemônicos inseridos não cofere com os cadastrados', 'info');
        //   } else {
        //     Http.post('/paramMascara', {
        //       IDOBRIGACDLOCAT: form.value.SelectCodigo,
        //       IDUTILIZAMASCCDLOCAT: form.value.SelectMascara,
        //       DSMASCCDLOCAT: form.value.InputMascara,
        //       IDALTERAMASCCDLOCAT: form.value.SelectPermissao,
        //       CDOPERADOR: window.localStorage.getItem('CDOPERADOR'),
        //     }).then((response: any) => {
        //       if (["OK"] == response.data[0]) {
        //         this.alertMessages('Paramêtro de Faturamento salvo com sucesso!', 'success');
        //       } else {
        //         this.dialogMessage('Operação bloqueada! Este Parâmetro de Faturamento não pôde ser salvo.<br><br>Se o problema persistir entre em contato com o suporte.');
        //       }
        //     })
        //   }

        // }

        if (form.validate()) {
            const paramConflito = Metadata.getInstance<ZdSelect>('selectValidacaoConflito').value;
            LoadingService.show();
            Http.post('/paramMascara', {
                CONFLITO: paramConflito,
            }).then(() => {
                Utilities.showSuccessMessage();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
        }
    }

    public getParametroConflito() {
        Http.get('/getParametroConflito').then((response) => {
            let parametro = response.data[0]['IDVALIDACRIATAREFA'];
            Metadata.getInstance<ZdSelect>('selectValidacaoConflito').value = parametro;
        })
    }

    public clickButtonToExpand({ component }: any) {
        const form = Metadata.getInstance<Form>(`formParametrizacao_${component.name}`);
        form.isVisible = !form.isVisible;
        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }


    public async openMnemonicosModal() {
        this.mnemonicosModal = await ModalService.create({
            name: 'mnemonicosModal',
            children: [
                {
                    name: 'mnemonicostHeader',
                    component: 'ZdHeader',
                    color: 'transparent',
                    padless: true,
                    elevation: 0,
                    leftSlot: [
                        {
                            name: 'titleText',
                            component: 'ZdText',
                            text: 'Mnemônicos',
                        },
                    ],
                    rightSlot: [
                        {
                            name: "closeModal",
                            component: "ZdButton",
                            iconName: "mdi-close",
                            icon: true,
                            events: {
                                click: "{{ControllerParametrizacaoGeral.closeMnemonicosModal}}"
                            }
                        },
                    ],
                },
                {
                    name: 'form',
                    component: 'ZdForm',
                    children: [
                        {
                            name: 'MnemonicoSeq',
                            component: 'ZdText',
                            text: '[SEQ]',
                            grid: {
                                cols: 3,
                            }
                        },
                        {
                            name: 'DescricaoSeq',
                            component: 'ZdText',
                            text: '– Número sequencial para geração da máscara.',
                            grid: {
                                cols: 9,
                            }
                        },
                        {
                            name: 'MnemonicoSetor',
                            component: 'ZdText',
                            text: '[SETOR]',
                            grid: {
                                cols: 3,
                            }
                        },
                        {
                            name: 'DescricaoSetor',
                            component: 'ZdText',
                            text: '– Nome do setor.',
                            grid: {
                                cols: 9,
                            }
                        },
                        {
                            name: 'MnemonicoLocalAtendimento',
                            component: 'ZdText',
                            text: '[NMABLOC]',
                            grid: {
                                cols: 3,
                            }
                        },
                        {
                            name: 'DescricaoLocalAtendimento',
                            component: 'ZdText',
                            text: '– Nome abreviado do local de atendimento.',
                            grid: {
                                cols: 9,
                            }
                        },
                        {
                            name: 'MnemonicoLocalSuperior',
                            component: 'ZdText',
                            text: '[NMABLOCS]',
                            grid: {
                                cols: 3,
                            }
                        },
                        {
                            name: 'DescricaoLocalSuperior',
                            component: 'ZdText',
                            text: '– Nome abreviado do local de atendimento superior.',
                            grid: {
                                cols: 9,
                            }
                        },
                        {
                            name: 'MnemonicoTodosLocais',
                            component: 'ZdText',
                            text: '[NMABLOCSALL{}]',
                            grid: {
                                cols: 3,
                            }
                        },
                        {
                            name: 'DescricaoTodosLocais',
                            component: 'ZdText',
                            text: '– Nome abreviado de todos os locais de atendimento superiores, no caso o delimitador que separa os locais, deve ser colocado dento das chaves.',
                            grid: {
                                cols: 9,
                            }
                        },
                    ],
                },
            ],
        });
        this.mnemonicosModal.show();
    }

    public closeMnemonicosModal() {
        this.mnemonicosModal.hide();
        this.mnemonicosModal?.destroy();
    }

    public alertMessages(message: string, type: string) {
        AlertService.show({
            name: 'basic-alert',
            text: message,
            top: true,
            left: false,
            timeout: 3000,
            color: type,
        });
    }

    public dialogMessage(message: string, tip: string = 'warning') {
        DialogService.show({
            name: 'warning-dialog',
            type: tip,
            title: (tip === 'info') ? 'Atenção' : 'Ocorreu um erro!',
            text: message,
        });
    }
}
